/**

code to fetch ticket info...

*/
static RooTicket  _RooTicket;



class RooTicket : Object
{
 	
 	
 	public static RooTicket singleton()
    {
        if (_RooTicket == null) {
            _RooTicket = new RooTicket();
            _RooTicket.tickets = new Gee.ArrayList<RooTicket>();
        }
        return _RooTicket;
    }
	public Gee.ArrayList<RooTicket> tickets; // only available for singletonn.
	public string username = ""; // only available for singletonn.
	public string password = ""; // only available for singletonn.


	public string  id; // not really important that they are numbers..
	public string summary;
	public string description;
	public string project_id_name;


 	public string summaryToBranchName()
 	{
 		// first 5 words of summary..
 		var  regex = new Regex ("[^A-Za-z0-9 ]+");
 		var str = regex.replace(this.summary, this.summary.length, 0);
		string[] words = Regex.split_simple ("[ \t]+", str);
		var ret = "";
		for (var i =0; i< (words.length > 5 ? 5 : words.length); i++) {
			ret += ret.length > 0 ? "_" : "";
			ret += words[i];
		}
		return ret;
		
 	}
	public string usernameLocal()
	{
		// git username is an email addres... - so this reutrns the local part..
		//?? assumes that all members are under the same domain... normally the case......
		return RooTicket.singleton().username.split('@')[0];
	
	}


	public void addTicket(Json.Object t)
	{
		var add = new RooTicket();
		add.id = t.get_string_member("id");
		add.summary = t.get_string_member("summary");
		add.description = t.get_string_member("description");
		add.project_id_name = t.get_string_member("project_id_name");						
		this.tickets.add(add);
		GLib.debug("ADD ticket  %s : %s : %s", add.id, add.summary, add.project_id_name);
	}
 
 	public RooTicket? getById(string id)
 	{
 		foreach(var t in this.tickets) {
 			if (t.id == id) {
 				return t;
			}
		}
		return null;
 
 	}


	public void loadTickets()
	{
		RooTicket.singleton().tickets = new Gee.ArrayList<RooTicket>();
		
		var url = "https://roojs.com/admin.php/Roo/mtrack_ticket";
    		
		var table = new GLib.HashTable<string, string>(str_hash, str_equal);
	 
		table.insert("query[viewtype]","active");
		table.insert("developer_id","494");
		table.insert("limit","999");
		table.insert("sort","summary");
		table.insert("dir","ASC");

		var params = Soup.Form.encode_hash(table);
		
		url = "%s?%s" . printf(url, params);
		
		GLib.debug("request %s", url);
		
		var session = new Soup.Session ();
		session.timeout = 0;
		var message = new Soup.Message ("GET", url);
		
		
		RooTicket.setAuth(message);
		
		session.send_message (message);
		
		var data = (string) message.response_body.flatten().data;
		GLib.debug("got %s", data);
		try {
			var parser = new Json.Parser ();
			parser.load_from_data (data, -1);

			var response = parser.get_root().get_object();
			var status = response.get_boolean_member("success");
		
			if(!status){
				GLib.error(response.get_string_member("errorMsg"));
				return;
			}
			var rd = response.get_array_member ("data");
			
			// got a valid result...
			var _this = RooTicket.singleton();
			for(var i = 0; i < rd.get_length(); i++) {
				_this.addTicket(rd.get_object_element(i));
			}
			 
		
		} catch (Error e) {
			GLib.error(e.message);
			return;
		}
		
	}
	
	public  static void setAuth(Soup.Message message) 
	{
		var rs =  RooTicket.singleton();		
		if (rs.username.length < 1) {
			string str;
			GLib.FileUtils.get_contents(GLib.Environment.get_home_dir() + "/.netrc", out str);
			var lines = str.split("\n");
			for(var i=0; i< lines.length; i++) {
			// assumes one line per entry.. if not we are buggered...
					GLib.debug("got %s" , lines[i]);
			
				var bits =  Regex.split_simple ("[ \t]+", lines[i].strip());
				if (bits.length < 6 || bits[0] != "machine" || bits[1] != "git.roojs.com") {
					continue;
				}
					GLib.debug("found password?");
				// we are gussing.... 
				username = bits[3];
				password = bits[5];
				RooTicket.singleton().username  = bits[3];
				RooTicket.singleton().password  = bits[5];		
			}
		}


		var authCode = Base64.encode ("%s:%s".printf(rs.username, rs.password).data);
		message.request_headers.append("Authorization", "Basic %s".printf(authCode));
	
	
	}


	
	
	
 }